{
  TUTOR3.PAS

  explains the usage of SetWindow
}

uses dos, crt, _VidKRNL, _VID111, _XLSP111;

var
  sonicGFX : TSprite;     { this is a sprite }
  titleGFX : TXLSprite;   { just another sprite, but a XL with more than 64KBytes }
  sonicPAL : TPal;        { this is a 256 color palette }
  page1    : TPage111h;   { this is a virtual page }

  x,y      : integer; { needed for the sonic position }

begin
  { initialise the Video111h variables. Call this procedure first }
  InitVideo111h;

  { load the Sonic-Palette palette }
  loadPalette( '.\PAL\SONIC.PAL', sonicPAL );

  { loads SONIC1-1.CLB to the sonicGFX sprite and
          TITLE1.CLB to the titleGFX sprite }
  LoadImprocesCLB( '.\GFX\SONIC1-1.CLB', sonicGFX, sonicPAL );
  LoadXLImprocesCLB( '.\TITLE\TITLE1.CLB',   titleGFX, sonicPAL );

  { initialise the Page1 }
  InitPage111h( Page1 );

  { switch on the 640x480x64k Mode }
  SetVideoMode111h( Mode111h );

  { all outputs go now to Page1, our first virtual page }
  ActivePage111H( Page1 );

  { initialise the sonic position }
  x := 0;
  y := 0;

  { sets new window borders.
    Usage : SetWindow111h( x1,y1 ,x2,y2);
    (x1, y1) is the upper left point of the window,
    (x2, y2) is the bottom right point of the window. }
  SetWindow111h( 10, 10, 630, 470 );

  repeat
    { Clears the Page Page1; fills it with 0's }
    ClearPage111h( Page1 );

    { draws the sprite titleGFX to screenposition x,y }
    PutXLSpriteWindow111h(   0,   0, titleGFX );
    PutXLSpriteWindow111h( 320,   0, titleGFX );
    PutXLSpriteWindow111h( 320, 200, titleGFX );
    PutXLSpriteWindow111h(   0, 200, titleGFX );

    { draws the sprite sonicGFX to Screenposition x,y }
    PutSpriteWindow111h( x, y, sonicGFX );

    { draws a transparent version of sonic to position 320-x, y }
    PutSpriteWindowTrans111h( 640 - x, y, 0, sonicGFX );

    { wait for a verticale retrace of the monitor;
      use this to make smooth scrolling and flicker free animations }
    Retrace;

    { copy the virtual Page Page1 to the VisualPage; also posssible would
      be CopyP2P111h ( Page1, VisualPage ) }
    CopyP2V111h( Page1 );

    if x < 639 then { let the sonic doing some movements }
        inc( x, 5 )
      else
        begin
          x := 0;
          inc( y, 5 );
        end;
    if y > 479 then y := 0;

  until keypressed; { wait for a key pressed }

  { gives the page memory back to system }
  ClosePage111h(Page1);

  { gives the sprite memory back to system }
  CloseSprite( sonicGFX );
  CloseXLSprite( titleGFX );

  { switch back to normal text mode 80x25 }
  SetVideoMode111h( Mode3h );

  { Closes the Video111h. Should be the last instruction in your programm }
  CloseVideo111h;
end.